//+------------------------------------------------------------------+
//|                                                jurik crosses.mq4 |
//|                                                           mladen |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Maroon
#property indicator_color3 LimeGreen
#property indicator_color4 Green
#property indicator_color5 Gold
#property indicator_color6 Green
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern int    FastJmaPrice        = 0;
extern double FastJmaLength       = 20;
extern double FastJmaPhase        = 0;
extern bool   FastJmaSmoothDouble = true;
extern int    SlowJmaPrice        = 0;  
extern double SlowJmaLength       = 50;  
extern double SlowJmaPhase        = 0;
extern bool   SlowJmaSmoothDouble = true;
extern int    SignalLength        =  9;
extern bool   Interpolate         = true;

//
//
//
//
//

double jurgCross[];
double jurrCross[];
double upBuffer1[];
double upBuffer2[];
double dnBuffer1[];
double dnBuffer2[];
double jurdiff[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,dnBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,dnBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,upBuffer1); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,upBuffer2); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,jurrCross);  
      SetIndexBuffer(5,jurgCross);   
      SetIndexBuffer(6,jurdiff);  
      SetIndexBuffer(7,trend);
      
      SetIndexLabel(4,"Jurik trix "+ SlowJmaLength);
      SetIndexLabel(5,"Jurik trix "+ FastJmaLength);   

      //
      //
      //
      //
      //
   
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" Jurik trix  ("+DoubleToStr(FastJmaLength,2)+","+DoubleToStr(SlowJmaLength,2)+")");
   return(0);
}

//
//
//
//
//

int deinit(){ return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { dnBuffer1[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //


   if (calculateValue || timeFrame==Period())
   {
   
      if (ArrayRange(work,0) != Bars) { ArrayResize(work,Bars); }
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
      
         double Fma = iMA(NULL,0,1,0,MODE_SMA,FastJmaPrice,i);
         double Sma = iMA(NULL,0,1,0,MODE_SMA,SlowJmaPrice,i);
      
      
         work[r][0]   = iDSmooth(Fma,FastJmaLength,FastJmaPhase,FastJmaSmoothDouble,i, 0);  
         work[r][1]   = iDSmooth(Sma,SlowJmaLength,SlowJmaPhase,SlowJmaSmoothDouble,i,20);
         jurgCross[i] = work[r][0]-work[r-1][0];
         jurrCross[i] = work[r][1]-work[r-1][1];
         jurdiff[i]   = jurgCross[i]-jurrCross[i];
         upBuffer1[i] = EMPTY_VALUE;
         upBuffer2[i] = EMPTY_VALUE;
         dnBuffer1[i] = EMPTY_VALUE;
         dnBuffer2[i] = EMPTY_VALUE;
         trend[i]     = trend[i+1];
            if (jurdiff[i]>jurdiff[i+1]) trend[i] =  1;
            if (jurdiff[i]<jurdiff[i+1]) trend[i] = -1;
            if (jurdiff[i]>0)
               if (trend[i] == 1)
                     upBuffer1[i] = jurdiff[i];
               else  upBuffer2[i] = jurdiff[i];
            else               
               if (trend[i] == 1)
                     dnBuffer2[i] = jurdiff[i];
               else  dnBuffer1[i] = jurdiff[i];
      }
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
          jurgCross[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastJmaPrice,FastJmaLength,FastJmaPhase,FastJmaSmoothDouble,SlowJmaPrice,SlowJmaLength,SlowJmaPhase,SlowJmaSmoothDouble,4,y);
          jurrCross[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastJmaPrice,FastJmaLength,FastJmaPhase,FastJmaSmoothDouble,SlowJmaPrice,SlowJmaLength,SlowJmaPhase,SlowJmaSmoothDouble,5,y);
          jurdiff[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastJmaPrice,FastJmaLength,FastJmaPhase,FastJmaSmoothDouble,SlowJmaPrice,SlowJmaLength,SlowJmaPhase,SlowJmaSmoothDouble,6,y);
          trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastJmaPrice,FastJmaLength,FastJmaPhase,FastJmaSmoothDouble,SlowJmaPrice,SlowJmaLength,SlowJmaPhase,SlowJmaSmoothDouble,7,y);
          upBuffer1[i] = EMPTY_VALUE;
          upBuffer2[i] = EMPTY_VALUE;
          dnBuffer1[i] = EMPTY_VALUE;
          dnBuffer2[i] = EMPTY_VALUE;
          if (jurdiff[i]>0)
             if (trend[i] == 1)
                   upBuffer1[i] = jurdiff[i];
             else  upBuffer2[i] = jurdiff[i];
          else               
             if (trend[i] == 1)
                   dnBuffer2[i] = jurdiff[i];
             else  dnBuffer1[i] = jurdiff[i];

         //
         //
         //
         //
         //

         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               jurgCross[i+k] = jurgCross[i] + (jurgCross[i+n]-jurgCross[i])*k/n;
               jurrCross[i+k] = jurrCross[i] + (jurrCross[i+n]-jurrCross[i])*k/n;
               jurdiff[i+k]   = jurdiff[i]   + (jurdiff[i+n]  -jurdiff[i])*k/n;
               
                  //
                  //
                  //
                  //
                  //
                  
                  if (upBuffer1[i+k]!=EMPTY_VALUE) upBuffer1[i+k] = jurdiff[i+k];
                  if (upBuffer2[i+k]!=EMPTY_VALUE) upBuffer2[i+k] = jurdiff[i+k];
                  if (dnBuffer1[i+k]!=EMPTY_VALUE) dnBuffer1[i+k] = jurdiff[i+k];
                  if (dnBuffer2[i+k]!=EMPTY_VALUE) dnBuffer2[i+k] = jurdiff[i+k];
            }
                  
   }

   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}